// NfoView XP - small and simple NFO viewer
// =================================================================================
// Author        : Slip
// Email         : slip_2k5@pisem.net
// Homepage      : http://slip.31337.pl
// IDE           : Borland Delphi 7
// =================================================================================
// Last modified : 20.11.2005

program Nfoview;

uses
  Windows, Messages, CommDlg, Commctrl, ShellAPI, ShlObj;

const

  IDMENU =              1000;
  IDMOPEN =             1001;
  IDMEXIT =             1002;
  IDMABOUT =            1003;
  IDMSETTINGS =         1004;
  IDMHOMEPAGE =         1005;

  IDOPTIONSDIALOG =     100;
  IDOFONTEDIT =         101;
  IDOBGCOLOREDIT =      102;
  IDOTEXTCOLOREDIT =    103;
  IDOFONTBUTTON =       104;
  IDOBGCOLORBUTTON =    105;
  IDOTEXTCOLORBUTTON =  106;
  IDODONEBUTTON =       107;
  IDOPREVIEWMEMO =      108;
  IDOSTATUSLABEL =      109;
  IDOSETDEFAULTBUTTON = 110;
  IDOCHECKDEFAULTCB =   111;
  IDOONEINSTANCECB =    112;

  IDTOOLBARBITMAP =     200;

  IDICON =              300;

  IDCHECKDIALOG =       400;
  IDCYESBUTTON =        401;
  IDCNOBUTTON =         402;
  IDCCB =               403;

  IDACCTABLE =          500;

  ClassWindow =         'NfoViewMainWindowClass';
  TitleWindow =         'NfoView XP 0.5';
  ClassMenu =           'NfoVewMenu';
  Tire =                ' - ';

  IniFile =             'NfoView.ini';
  Settings =            'Settings';
  Top_ =                'Top';
  Left_ =               'Left';
  Height_ =             'Height';
  Width_ =              'Width';
  State =               'State';
  FontSize =            'FontSize';
  FontName =            'FontName';
  d_ =                  '%d';
  x_ =                  '%06X';
  BGColor_ =            'BGColor';
  TextColor_ =          'TextColor';
  CheckDefault =        'CheckDefault';
  OneInstance =         'OneInstance';

  OFN_HIDEREADONLY =    $00000004;
  EM_SETWORDWRAPMODE =  WM_USER + 102;
  WBF_WORDWRAP =        $010;

  WM_SLIP =             WM_USER+666;

  //About =               'About';
  AboutText =           'NfoView XP 0.5 by Slip'#13'http://slip.31337.pl  slip_2k5@pisem.net';
  open =                'open';
  Homepage =            'http://slip.31337.pl';

  Cant_open_file =      'Can''t open file';
  File_is_big =         '65536 bytes - Maximum!!!';
  Error =               'Error';

  NfoViewFile =         'NfoViewFile';
  shell =               '\shell';
  shell_open =          '\shell\open';
  shell_open_command =  '\shell\open\command';
  shell_open_command_value_1 = '"';
  shell_open_command_value_2 = '" %1';
  //test =                'test';
  _nfo =                '.nfo';
  _diz =                '.diz';
  open_in =             'Open in &NfoView';
  defaulticon =         '\DefaultIcon';
  i0 =                  ',0';

  this_is_default =     'This application is the default NFO viewer';

  filter =              'All Supported Files'#0'*.nfo;*.diz;'#0'NFO Files'#0'*.nfo'#0'DIZ Files'#0'*.diz'#0'TXT Files'#0'*.txt'#0'All Files'#0'*.*'#0;

type
  MYOPENFILENAME = packed record
    lStructSize:        DWORD;
    hWndOwner:          HWND;
    hInstance:          HINST;
    lpstrFilter:        PChar;
    lpstrCustomFilter:  PChar;
    nMaxCustFilter:     DWORD;
    nFilterIndex:       DWORD;
    lpstrFile:          PChar;
    nMaxFile:           DWORD;
    lpstrFileTitle:     PChar;
    nMaxFileTitle:      DWORD;
    lpstrInitialDir:    PChar;
    lpstrTitle:         PChar;
    Flags:              DWORD;
    nFileOffset:        Word;
    nFileExtension:     Word;
    lpstrDefExt:        PChar;
    lCustData:          LPARAM;
    lpfnHook:           Pointer;
    lpTemplateName:     PChar;
  end;

var
  Wc:                   WNDCLASSEX;
  Msg:                  tagMSG;
  hWin:                 HWND;
  hMemo:                HWND;
  hStatusBar:           HWND;
  hToolBar:             HWND;
  Rect:                 TRect;
  Font:                 HFONT;
  LFont:                LOGFONT;
  BGBrush:              HBRUSH;
  Icon:                 HICON;
  AccTable:            HACCEL;

  Left:                 DWORD = 100;
  Top:                  DWORD = 100;
  Height:               DWORD = 600;
  Width:                DWORD = 500;
  Maximized:            DWORD = 0;

  NFOFileName:          array [0..MAX_PATH] of Char;
  Buffer:               array [0..MAX_PATH] of Char;
  Buffer2:              array [0..MAX_PATH] of Char;
  pBuffer:              PChar;

  NFO:                  Pointer;

  BGColor:              DWORD = $0000000;
  TextColor:            DWORD = $000FF00;
  TempColor:            DWORD;

  Buttons:              array [0..10] of _TBBUTTON;
  Panels:               array [0..2] of DWORD = (500, 600, 700);

  bCheckDefault:        BOOL;
  bOneInstance:         BOOL;

  CommandLine:          array [0..MAX_PATH] of Char;
  ExeName:              array [0..MAX_PATH] of Char;

  regsz:                DWORD = REG_SZ;

{$R rsrc.res}

function GetOpenFileName(lpTag:Pointer):BOOL;stdcall;external 'comdlg32.dll' name 'GetOpenFileNameA';
//function ChooseFont(lpTag:Pointer):BOOL;stdcall;external 'comdlg32.dll' name 'GetOpenFileNameA';
function InitCommonControls:BOOL; stdcall; external 'comctl32.dll' name 'InitCommonControls';

function GetShortName(FileName:PChar):BOOL;
var
  i,
  l,
  t:                    Integer;
  Ch:                   Char;
  Buffer:               array [0..MAX_PATH] of Char;
begin
  t:=-1;
  l:=lstrlen(FileName);
  for i:=1 to l do
  begin
    Ch:=FileName[i];
    if Ch='\' then
      t:=-1
    else
     Buffer[t]:=Ch;
    Inc(t); 
  end;
  lstrcpy(FileName, Buffer);
  result:=TRUE;
end;
// <--------------------------------------------------------------------------->
function OpenDialog(hDlg: HWND; Filter: PChar; var FileName:PChar; DefaultDir,Title:PChar):BOOL;
var
  ofn:                  MYOPENFILENAME;
  OfnFile:              array[0..MAX_PATH] of Char;
begin
  OfnFile[0]:=#0;
  ZeroMemory(@ofn, sizeof(ofn));
  ofn.lStructSize:=sizeof(ofn);
  ofn.hWndOwner:=hDlg;
  ofn.lpstrFilter:=Filter;
  ofn.nFilterIndex:=0;
  ofn.lpstrFile:=OFNFile;
  ofn.nMaxFile:=sizeof(OFNFile);
  ofn.lpstrFileTitle:=Buffer;
  ofn.nMaxFileTitle:=sizeof(Buffer);
  ofn.lpstrTitle:=Title;
  ofn.lpstrInitialDir:=DefaultDir;
  ofn.Flags:=OFN_HIDEREADONLY;
  Result:=GetOpenFileName(@ofn);
  FileName:=ofn.lpstrFile;
end;
// <--------------------------------------------------------------------------->
procedure FontDialog(hWnd:HWND);
var
  Cf:                   tagCHOOSEFONT;
  Lf:                   tagLOGFONT;
  Rect:                 TRect;
begin
  ZeroMemory(@Cf, sizeof(tagCHOOSEFONT));
  Cf.lStructSize:=sizeof(tagCHOOSEFONT);
  Cf.hWndOwner:=hWnd;
  Lf:=LFont;
  Cf.lpLogFont:=@Lf;
  Cf.Flags:=CF_SCREENFONTS or CF_FIXEDPITCHONLY or CF_INITTOLOGFONTSTRUCT;
  if ChooseFont(Cf) then
  begin
    DeleteObject(Font);
    Cf.lpLogFont.lfCharSet:=OEM_CHARSET;
    Lf.lfCharSet:=OEM_CHARSET;
    LFont:=Lf;
    Font:=CreateFontIndirect(LFont);
    SendMessage(hMemo, WM_SETFONT, Font, 0);
    GetClientRect(hWin, Rect);
    InvalidateRect(hWin, @Rect, TRUE);
  end;
end;
// <--------------------------------------------------------------------------->
function ColorDialog(hWnd:HWND; var Color:DWORD):BOOL;
var
 Cc:                    tagCHOOSECOLOR;
 CustArray:             array [0..15] of DWORD;
 ResultColor:           DWORD;
begin
  ZeroMemory(@CustArray, 16*sizeof(DWORD));
  ZeroMemory(@Cc, sizeof(tagCHOOSECOLOR));
  Cc.lStructSize:=sizeof(tagCHOOSECOLOR);
  Cc.hWndOwner:=hWnd;
  Cc.lpCustColors:=@CustArray;
  ResultColor:=Color;
  Cc.rgbResult:=ResultColor;
  Cc.Flags:=CC_RGBINIT or CC_FULLOPEN;
  Result:=ChooseColor(Cc);
  if Result then
    Color:=Cc.rgbResult;
end;
// <--------------------------------------------------------------------------->
function IsDefault:BOOL;
var
  Key:                  HKEY;
  Len:                  Integer;
begin
  Result:=TRUE;
  if RegOpenKeyEx(HKEY_CLASSES_ROOT, _nfo, 0, KEY_READ, Key)=ERROR_SUCCESS then
  begin
    Len:=MAX_PATH;
    RegQueryValueEx(Key, nil, nil, nil,	@Buffer, @Len);
    RegCloseKey(Key);
    lstrcat(Buffer, shell_open_command);
    Len:=MAX_PATH;
    if RegOpenKeyEx(HKEY_CLASSES_ROOT, Buffer, 0, KEY_READ, Key)=ERROR_SUCCESS then
    begin
      Len:=MAX_PATH;
      RegQueryValueEx(Key, nil, nil, nil, @Buffer2, @Len);
      RegCloseKey(Key);
      lstrcpy(Buffer, shell_open_command_value_1);
      lstrcat(Buffer, ExeName);
      lstrcat(Buffer, shell_open_command_value_2);
      //MessageBox(hWin, Buffer, 0, 0);
      //MessageBox(hWin, Buffer2, 0, 0);
      lstrcpy(Buffer, CharLower(Buffer));
      lstrcpy(Buffer2, CharLower(Buffer2));
      if lstrcmp(Buffer, Buffer2)<>0 then
        Result:=FALSE;
    end
    else
    Result:=FALSE;
  end
  else
    Result:=FALSE;
end;
// <--------------------------------------------------------------------------->
procedure SetDefault;
var
  Key:                  HKEY;
  Len:                  DWORD;
begin
// create .nfo
  if RegCreateKeyEx(HKEY_CLASSES_ROOT,
                    _nfo,
                    0,
                    nil,
                    REG_OPTION_NON_VOLATILE,
                    KEY_ALL_ACCESS,
                    nil,
                    Key,
                    nil)=ERROR_SUCCESS then
  begin
    Len:=lstrlen(NfoViewFile);
    RegSetValueEx(Key, nil, 0, regsz, PChar(NfoViewFile), Len);
    RegCloseKey(Key);
  end;
// create .diz
  if RegCreateKeyEx(HKEY_CLASSES_ROOT,
                    _diz,
                    0,
                    nil,
                    REG_OPTION_NON_VOLATILE,
                    KEY_ALL_ACCESS,
                    nil,
                    Key,
                    nil)=ERROR_SUCCESS then
  begin
    Len:=lstrlen(NfoViewFile);
    RegSetValueEx(Key, nil, 0, regsz, PChar(NfoViewFile), Len);
    RegCloseKey(Key);
  end;
// create NfoViewFile\shell\open\command
  lstrcpy(Buffer, NfoViewFile);
  lstrcat(Buffer, shell_open_command);
  if RegCreateKeyEx(HKEY_CLASSES_ROOT,
                    Buffer,
                    0,
                    nil,
                    REG_OPTION_NON_VOLATILE,
                    KEY_ALL_ACCESS,
                    nil,
                    Key,
                    nil)=ERROR_SUCCESS then
  begin
    lstrcpy(Buffer2, shell_open_command_value_1);
    lstrcat(Buffer2, ExeName);
    lstrcat(Buffer2, shell_open_command_value_2);
    Len:=lstrlen(Buffer2);
    RegSetValueEx(Key, nil, 0, regsz, @Buffer2, Len);
    RegCloseKey(Key);
  end;
// create NfoViewFile\DefaultIcon
  lstrcpy(Buffer, NfoViewFile);
  lstrcat(Buffer, defaulticon);
  if RegCreateKeyEx(HKEY_CLASSES_ROOT,
                    Buffer,
                    0,
                    nil,
                    REG_OPTION_NON_VOLATILE,
                    KEY_ALL_ACCESS,
                    nil,
                    Key,
                    nil)=ERROR_SUCCESS then
  begin
    lstrcpy(Buffer2, ExeName);
    lstrcat(Buffer2, i0);
    Len:=lstrlen(Buffer2);
    RegSetvalueEx(Key, nil, 0, regsz, @Buffer2, Len);
    RegCloseKey(Key);
  end;
  lstrcpy(Buffer, NfoViewFile);
  lstrcat(Buffer, shell);
  if RegCreateKeyEx(HKEY_CLASSES_ROOT,
                    Buffer,
                    0,
                    nil,
                    REG_OPTION_NON_VOLATILE,
                    KEY_ALL_ACCESS,
                    nil,
                    Key,
                    nil)=ERROR_SUCCESS then
  begin
    lstrcpy(Buffer2, open);
    Len:=lstrlen(Buffer2);
    RegSetvalueEx(Key, nil, 0, regsz, @Buffer2, Len);
    RegCloseKey(Key);
  end;
  lstrcpy(Buffer, NfoViewFile);
  lstrcat(Buffer, shell_open);
  if RegCreateKeyEx(HKEY_CLASSES_ROOT,
                    Buffer,
                    0,
                    nil,
                    REG_OPTION_NON_VOLATILE,
                    KEY_ALL_ACCESS,
                    nil,
                    Key,
                    nil)=ERROR_SUCCESS then
  begin
    lstrcpy(Buffer2, open_in);
    Len:=lstrlen(Buffer2);
    RegSetvalueEx(Key, nil, 0, regsz, @Buffer2, Len);
    RegCloseKey(Key);
  end;
  SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);
end;
// <--------------------------------------------------------------------------->
procedure LoadSettings;
begin
  Top:=GetPrivateProfileInt(Settings, Top_, 200, IniFile);
  Left:=GetPrivateProfileInt(Settings, Left_, 200, IniFile);
  Width:=GetPrivateProfileInt(Settings, Width_, 200, IniFile);
  Height:=GetPrivateProfileInt(Settings, Height_, 200, IniFile);
  Maximized:=GetPrivateProfileInt(Settings, State, WS_OVERLAPPEDWINDOW, IniFile);
  LFont.lfHeight:=GetPrivateProfileInt(Settings, FontSize, -12, IniFile);
  GetPrivateProfileString(Settings, FontName, 'Terminal', LFont.lfFaceName, LF_FACESIZE, IniFile);
  BGColor:=GetPrivateProfileInt(Settings, BGColor_, $8080FF, IniFile);
  TextColor:=GetPrivateProfileInt(Settings, TextColor_, $FFFFFF, IniFile);
  bCheckDefault:=BOOL(GetPrivateProfileInt(Settings, CheckDefault, 1, IniFile));
  bOneInstance:=BOOL(GetPrivateProfileInt(Settings, OneInstance, 1, IniFile));  
end;
// <--------------------------------------------------------------------------->
procedure SaveSettings;
var
  Rect:                 TRect;
  Style:                DWORD;
begin
  Style:=GetWindowLong(hWin, GWL_STYLE);
  wvsprintf(Buffer, d_, @Style);
  WritePrivateProfileString(Settings, State, Buffer, IniFile);
  if ((Style or WS_MAXIMIZE)<>Style) and ((Style or WS_MINIMIZE)<>Style) then
  begin
    GetWindowRect(hWin, Rect);
    Rect.Right:=Rect.Right-Rect.Left;
    Rect.Bottom:=Rect.Bottom-Rect.Top;
    wvsprintf(Buffer, d_, @Rect.Top);
    WritePrivateProfileString(Settings, Top_, Buffer, IniFile);
    wvsprintf(Buffer, d_, @Rect.Left);
    WritePrivateProfileString(Settings, Left_, Buffer, IniFile);
    wvsprintf(Buffer, d_, @Rect.Right);
    WritePrivateProfileString(Settings, Width_, Buffer, IniFile);
    wvsprintf(Buffer, d_, @Rect.Bottom);
    WritePrivateProfileString(Settings, Height_, Buffer, IniFile);
  end;
  wvsprintf(Buffer, d_, @LFont.lfHeight);  
  WritePrivateProfileString(Settings, FontSize, Buffer, IniFile);
  WritePrivateProfileString(Settings, FontName, LFont.lfFaceName, IniFile);
  wvsprintf(Buffer, d_, @BGColor);
  WritePrivateProfileString(Settings, BGColor_, Buffer, IniFile);
  wvsprintf(Buffer, d_, @TextColor);
  WritePrivateProfileString(Settings, TextColor_, Buffer, IniFile);
  wvsprintf(Buffer, d_, @bCheckDefault);
  WritePrivateProfileString(Settings, CheckDefault, Buffer, IniFile);
  wvsprintf(Buffer, d_, @bOneInstance);
  WritePrivateProfileString(Settings, OneInstance, Buffer, IniFile);
end;
// <--------------------------------------------------------------------------->
procedure OpenNFO(FileName:PChar);
var
  hFile:                THandle;
  dwFileSize:           DWORD;
  dwRB:                 DWORD;
begin
  hFile:=CreateFile(FileName,
                     GENERIC_READ,
                     FILE_SHARE_READ,
                     nil,
                     OPEN_EXISTING,
                     FILE_ATTRIBUTE_NORMAL,
                     0);
  if hFile=INVALID_HANDLE_VALUE then
  begin
    Buffer:=#0;
    wvsprintf(Buffer2, 'Can''t open file "%s" !', @FileName);
    MessageBox(hWin, Buffer2, Error, MB_ICONERROR);
    Exit;
  end;
  dwFileSize:=GetFileSize(hFile, nil);
  if dwFileSize>65536 then
  begin
    MessageBox(hWin, File_is_big, Error, MB_ICONERROR);
    Exit;
  end;
  GetMem(NFO, dwFileSize);
  ReadFile(hFile, NFO^, dwFileSize, dwRB, nil);
  for dwRB:=0 to dwFileSize do
    if BYTE(Pointer(DWORD(NFO)+dwRB)^)=$00 then
      BYTE(Pointer(DWORD(NFO)+dwRB)^):=$20;
  //SendMessage(hMemo, EM_SETLIMITTEXT, WPARAM(dwFileSize), 0);
  SendMessage(hMemo, WM_SETTEXT, 0, Integer(NFO));
  //SetWindowText(hMemo, NFO);
  lstrcpy(@NFOFileName, FileName);
  lstrcpy(Buffer, FileName);
  GetShortName(Buffer);
  lstrcat(Buffer, Tire);
  lstrcat(Buffer, TitleWindow);
  SendMessage(hWin, WM_SETTEXT, 0, Integer(@Buffer));
  //SendMessage(hStatusBar, WM_SETTEXT, 0, Integer(@NFOFileName));
  SendMessage(hStatusbar, SB_SETTEXT, MAKELONG(0,SBT_POPOUT), Integer(@NFOFileName));
  wvsprintf(Buffer, d_, @dwFileSize);
  SendMessage(hStatusbar, SB_SETTEXT, MAKELONG(2,SBT_POPOUT), Integer(@Buffer));
  FreeMem(NFO, dwFileSize);
  CloseHandle(hFile);
end;
// <--------------------------------------------------------------------------->
function CheckDialogFunction(hDlg:HWND; uMsg:UINT; wParam:WPARAM; lParam:LPARAM):DWORD;stdcall;

procedure Close;
begin
  bCheckDefault:=not (IsDlgButtonChecked(hDlg, IDCCB)=BST_CHECKED);
  EndDialog(hDlg, 0);
end;

begin
  case uMsg of
  WM_COMMAND:
    case LoWord(wParam) of
    IDCNOBUTTON:
      Close;
    IDCYESBUTTON:
      begin
        SetDefault;
        Close;
      end;
    end;
  WM_CLOSE:
    Close;
  end;
  Result:=0;
end;
// <--------------------------------------------------------------------------->
function OptionsDialogFunction(hDlg:HWND; uMsg:UINT; wParam:WPARAM; lParam:LPARAM):DWORD;stdcall;

procedure Close;
begin
  bCheckDefault:=IsDlgButtonChecked(hDlg, IDOCHECKDEFAULTCB)=BST_CHECKED;
  bOneInstance:=IsDlgButtonChecked(hDlg, IDOONEINSTANCECB)=BST_CHECKED;
  SaveSettings;
  EndDialog(hDlg, 0);
end;

procedure Show;
begin
  lstrcpy(Buffer, LFont.lfFaceName);
  SetDlgItemText(hDlg, IDOFONTEDIT, Buffer);
  wvsprintf(Buffer, x_, @TextColor);
  SetDlgItemText(hDlg, IDOTEXTCOLOREDIT, Buffer);
  wvsprintf(Buffer, x_, @BGColor);
  SetDlgItemText(hDlg, IDOBGCOLOREDIT, Buffer);
  SendDlgItemMessage(hDlg, IDOPREVIEWMEMO, WM_SETFONT, Font, 0);
  SetFocus(GetDlgItem(hDlg, IDODONEBUTTON));
end;

procedure Refresh;
begin
  GetClientRect(hWin, Rect);
  InvalidateRect(hWin, @Rect, TRUE);
  GetClientRect(hDlg, Rect);
  InvalidateRect(hDlg, @Rect, TRUE);
end;

procedure RefreshAssociations;
begin
  if bCheckDefault then
    CheckDlgButton(hDlg, IDOCHECKDEFAULTCB, BST_CHECKED);
  if IsDefault then
  begin
    EnableWindow(GetDlgItem(hDlg, IDOSETDEFAULTBUTTON), FALSE);
    SetDlgItemText(hDlg, IDOSTATUSLABEL, this_is_default);
  end;
end;

begin
  case uMsg of
    WM_CTLCOLOREDIT:
    begin
      SetTextColor(wParam, TextColor);
      SetBKColor(wParam, BGColor);
      Result:=BGBrush;
      Exit;
    end;
    WM_INITDIALOG:
    begin
      if bOneInstance then
        CheckDlgButton(hDlg, IDOONEINSTANCECB, BST_CHECKED);
      RefreshAssociations;
      Show;
    end;
    WM_COMMAND:
      case LoWord(wParam) of
        IDOFONTBUTTON:
        begin
          FontDialog(hDlg);
          Show;
        end;
        IDOBGCOLORBUTTON:
        begin
          TempColor:=BGColor;
          if ColorDialog(hDlg, TempColor) then
          begin
            DeleteObject(BGBrush);
            BGColor:=TempColor;
            BGBrush:=CreateSolidBrush(BGColor);
            Show;
            Refresh;
          end;
        end;
        IDOTEXTCOLORBUTTON:
        begin
          TempColor:=TextColor;
          if ColorDialog(hDlg, TempColor) then
          begin
            TextColor:=TempColor;
            Show;
            Refresh;
          end;
        end;
        IDODONEBUTTON:
          Close;
        IDOSETDEFAULTBUTTON:
        begin
          SetDefault;
          RefreshAssociations;
        end;
      end;
    WM_CLOSE:
      Close;
  end;
  Result:=0;
end;
// <--------------------------------------------------------------------------->
function MainWindowFunction(hWnd:HWND; uMsg:UINT; wParam:WPARAM; lParam:LPARAM):DWORD;stdcall;

procedure Close;
begin
  SaveSettings;
  PostQuitMessage(0);
end;

procedure Drop;
begin
  DragQueryFile(wParam, 0, Buffer, MAX_PATH);
  OpenNFO(Buffer);
  DragFinish(wParam);
end;

begin
  case uMsg of
  WM_CTLCOLOREDIT:
    begin
      SetTextColor(wParam, TextColor);
      SetBKColor(wParam, BGColor);
      Result:=BGBrush;
      Exit;
    end;
  WM_COMMAND:
    begin
      case LoWord(wParam) of
      IDMOPEN:
        begin
          if OpenDialog(hWnd, filter, pBuffer, NFOFileName, nil) then
          begin
            lstrcpy(Buffer, pBuffer);
            OpenNFO(Buffer);
          end;
        end;
      IDMSETTINGS:
        DialogBox(hInstance, MAKEINTRESOURCE(IDOPTIONSDIALOG), hWin, @OptionsDialogFunction);
      IDMEXIT:
        Close;
      IDMABOUT:
      begin
        MessageBeep(MB_ICONINFORMATION);
        ShellAbout(hWnd, TitleWindow, AboutText, Icon);
      end;
      IDMHOMEPAGE:
        ShellExecute(hWin, open, Homepage, nil, nil, SW_SHOWMAXIMIZED);
      end;
    end;
    WM_GETMINMAXINFO:
  begin
    PMINMAXINFO(lParam)^.ptMinTrackSize.x:=450;
    PMINMAXINFO(lParam)^.ptMinTrackSize.y:=300;
  end;
  WM_SIZE:
    begin
      Panels[0]:=LoWord(lParam)-200;
      Panels[1]:=LoWord(lParam)-75;
      Panels[2]:=LoWord(lParam);
      SendMessage(hStatusbar, SB_SETPARTS, 3, Integer(@Panels));
      MoveWindow(hToolBar, 0, 0, LoWord(lParam), 28, TRUE);
      MoveWindow(hMemo, 0, 28, LoWord(lParam), HiWord(lParam)-49, TRUE);
      MoveWindow(hStatusBar, LoWord(lParam) ,0, 21, HiWord(lParam), TRUE);
      Result:=0;
      Exit;
    end;
  WM_DROPFILES:
    Drop;
  WM_DESTROY:
    Close;
  WM_SLIP:
    begin
      GetWindowText(hWin, Buffer, MAX_PATH);
      //MessageBox(hWin, Buffer, 0, 0);
      OpenNFO(Buffer);
    end;
  end;
  Result:=DefWindowProc(hWnd, uMsg, wParam, lParam);
end;
// <--------------------------------------------------------------------------->
procedure ParseCommandLine;
var
  Len:                  WORD;
  i:                    WORD;
  Pos:                  WORD;
  Sp:                   WORD;
begin
  pBuffer:=GetCommandLine;
  lstrcpy(Buffer, pBuffer);
  Len:=lstrlen(Buffer);
  Pos:=0;
  for i:=0 to Len do
    Buffer[i]:=Buffer[i+1];
  for i:=0 to Len do
  begin
    if Buffer[i]='"' then
    begin
      Pos:=i;
      Buffer[i]:=#0;
      lstrcpy(ExeName, Buffer);
      Break;
    end;
  end;
  Sp:=1;
  while Buffer[Pos+Sp]=' ' do
  begin
    Inc(Sp);
  end;
  for i:=0 to Len-Pos+Sp do
    Buffer[i]:=Buffer[i+Pos+Sp];
  lstrcpy(CommandLine, Buffer);
end;
// <--------------------------------------------------------------------------->
procedure FakeWinMain;
var
  hPreWin:              HWND;
begin
  ParseCommandLine;
  //MessageBox(0, CommandLine, 0, 0);
  LoadSettings;
  if bOneInstance then
  begin
    hPreWin:=FindWindow(ClassWindow, nil);
    if hPreWin<>0 then
    begin
      if lstrlen(CommandLine)>0 then
      begin
        SendMessage(hPrewin, WM_SETTEXT, 0, DWORD(@CommandLine));
        SendMessage(hPreWin, WM_SLIP, 0, 0);
      end;
      SetForegroundWindow(hPreWin);
      Exit;
    end;
  end;

  Icon:=LoadIcon(hInstance, MAKEINTRESOURCE(IDICON));
  AccTable:=LoadAccelerators(hInstance, MAKEINTRESOURCE(IDACCTABLE));

  Wc.cbSize:=sizeof(WNDCLASSEX);
  //Wc.style:=CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW;
  Wc.lpfnWndProc:=@MainWindowFunction;
  Wc.cbClsExtra:=0;
  Wc.cbWndExtra:=0;
  Wc.hInstance:=hInstance;
  Wc.hbrBackground:=COLOR_BTNFACE+1;
  Wc.hIconSm:=Icon;
  Wc.lpszMenuName:=MAKEINTRESOURCE(IDMENU);
  Wc.lpszClassName:=ClassWindow;
  Wc.hCursor:=LoadCursor(hInstance, IDC_ARROW);
  if (RegisterClassEx(Wc)<>0) then
  begin
    //LFont.lfHeight:=-12;
    LFont.lfCharSet:=OEM_CHARSET;
    //LFont.lfFaceName:='Terminal';
    Font:=CreateFontIndirect(LFont);    
    hWin:=CreateWindowEx(WS_EX_ACCEPTFILES,
                         ClassWindow,
                         TitleWindow,
                         WS_OVERLAPPEDWINDOW,
                         Left,
                         Top,
                         Width,
                         Height,
                         0,
                         0,
                         hInstance,
                         nil);
    if bCheckDefault and (not IsDefault)
      then DialogBox(hInstance, MAKEINTRESOURCE(IDCHECKDIALOG), hWin, @CheckDialogFunction);

    GetClientRect(hWin, Rect);
    //LoadLibrary('Riched20.dll');
    hMemo:=CreateWindowEx(0,
                         'Edit',
                         nil,
                         ES_LEFT or ES_MULTILINE or WS_CHILD or WS_VISIBLE or WS_VSCROLL,
                         Rect.Left,
                         Rect.Top,
                         Rect.Right,
                         Rect.Bottom,
                         hWin,
                         0,
                         hInstance,
                         nil);

   Buttons[0].idCommand:=0;
   Buttons[0].fsState:=TBSTATE_ENABLED;
   Buttons[0].fsStyle:=TBSTYLE_SEP;
   Buttons[0].iBitmap:=-1;

   Buttons[1].idCommand:=IDMOPEN;
   Buttons[1].fsState:=TBSTATE_ENABLED;
   Buttons[1].fsStyle:=TBSTYLE_BUTTON;
   Buttons[1].iBitmap:=0;

   Buttons[2].idCommand:=0;
   Buttons[2].fsState:=TBSTATE_ENABLED;
   Buttons[2].fsStyle:=TBSTYLE_SEP;
   Buttons[2].iBitmap:=-1;

   Buttons[3].idCommand:=IDMSETTINGS;
   Buttons[3].fsState:=TBSTATE_ENABLED;
   Buttons[3].fsStyle:=TBSTYLE_BUTTON;
   Buttons[3].iBitmap:=2;

   Buttons[4].idCommand:=0;
   Buttons[4].fsState:=TBSTATE_ENABLED;
   Buttons[4].fsStyle:=TBSTYLE_SEP;
   Buttons[4].iBitmap:=-1;

   Buttons[5].idCommand:=IDMHOMEPAGE;
   Buttons[5].fsState:=TBSTATE_ENABLED;
   Buttons[5].fsStyle:=TBSTYLE_BUTTON;
   Buttons[5].iBitmap:=4;

   Buttons[6].idCommand:=IDMABOUT;
   Buttons[6].fsState:=TBSTATE_ENABLED;
   Buttons[6].fsStyle:=TBSTYLE_BUTTON;
   Buttons[6].iBitmap:=3;

   Buttons[7].idCommand:=0;
   Buttons[7].fsState:=TBSTATE_ENABLED;
   Buttons[7].fsStyle:=TBSTYLE_SEP;
   Buttons[7].iBitmap:=-1;

   Buttons[8].idCommand:=IDMEXIT;
   Buttons[8].fsState:=TBSTATE_ENABLED;
   Buttons[8].fsStyle:=TBSTYLE_BUTTON ;
   Buttons[8].iBitmap:=1;

   hToolbar:=CreateToolBarEx(hWin,
                   WS_CHILD or WS_VISIBLE or CCS_ADJUSTABLE or TBSTYLE_FLAT,
                   21,
                   9,
                   hInstance,
                   IDTOOLBARBITMAP,
                   @Buttons,
                   9,
                   16,
                   16,
                   15,
                   0,
                   sizeof(_TBBUTTON));
   hStatusBar:=CreateWindowEx(0,
                              'msctls_statusbar32',
                              nil,
                              SBARS_SIZEGRIP or WS_CHILD or WS_VISIBLE,
                              0,
                              0,
                              0,
                              0,
                              hWin,
                              0,
                              hInstance,
                              nil);
    SendMessage(hMemo, WM_SETFONT, Font, 0);
    SendMessage(hWin, WM_SETICON, ICON_BIG, Icon);
    //SendMessage(hMemo, EM_SETWORDWRAPMODE, WPARAM(WBF_WORDWRAP	), 0);
    BGBrush:=CreateSolidBrush(BGColor);
    if (Maximized or WS_MAXIMIZE)=Maximized then
      ShowWindow(hWin, SW_MAXIMIZE)
    else
      ShowWindow(hWin ,SW_SHOW);
    UpdateWindow(hWin);
    if lstrlen(CommandLine)<>0 then
      OpenNFO(CommandLine);

    while GetMessage(Msg, 0, 0, 0) do
    begin
      TranslateAccelerator(hWin, AccTable, Msg);
      TranslateMessage(Msg);
      DispatchMessage(Msg);
    end;
  end;
  DeleteObject(Icon);
  DestroyAcceleratorTable(AccTable);
end;
// <--------------------------------------------------------------------------->
begin
  FakeWinMain;
end.
